/*
    These is sample code for giving effects to RGB led Strip_1 connected to a evive.
    The Din pin of LED Strip_1 is connected to Digital pin 2 of evive.
    you can change the pattern by sliding the slide switch.
    Made by Satya Zaveri.
    On 11 september 2019.

  Explore more on: https://create.arduino.cc/projecthub/theSTEMpedia
*/
#include <evive.h>
#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel Strip_1 = Adafruit_NeoPixel(10, 2, NEO_GRB + NEO_KHZ800);
void setup() {
Strip_1.begin();
Strip_1.show();
pinMode(40, INPUT);
}
void loop() {
if(digitalRead(40)) {
theaterChaseRainbow(0.05*1000);
}
 else {
rainbow(0.01*1000);
}
}

void theaterChaseRainbow(int wait) {
  int firstPixelHue = 0;     // First pixel starts at red (hue 0)
  for (int a = 0; a < 30; a++) { // Repeat 30 times...
    for (int b = 0; b < 3; b++) { //  'b' counts from 0 to 2...
      Strip_1.clear();         //   Set all pixels in RAM to 0 (off)
      // 'c' counts up from 'b' to end of Strip_1 in increments of 3...
      for (int c = b; c < Strip_1.numPixels(); c += 3) {
        // hue of pixel 'c' is offset by an amount to make one full
        // revolution of the color wheel (range 65536) along the length
        // of the Strip_1 (Strip_1.numPixels() steps):
        int      hue   = firstPixelHue + c * 65536L / Strip_1.numPixels();
        uint32_t color = Strip_1.gamma32(Strip_1.ColorHSV(hue)); // hue -> RGB
        Strip_1.setPixelColor(c, color); // Set pixel 'c' to value 'color'
      }
      Strip_1.show();                // Update Strip_1 with new contents
      delay(wait);                 // Pause for a moment
      firstPixelHue += 65536 / 90; // One cycle of color wheel over 90 frames
    }
  }
}
void rainbow(int wait) {
  // Hue of first pixel runs 3 complete loops through the color wheel.
  // Color wheel has a range of 65536 but it's OK if we roll over, so
  // just count from 0 to 3*65536. Adding 256 to firstPixelHue each time
  // means we'll make 3*65536/256 = 768 passes through this outer loop:
  for(long firstPixelHue = 0; firstPixelHue < 3*65536; firstPixelHue += 256) {
    for(int i=0; i<Strip_1.numPixels(); i++) { // For each pixel in Strip_1...
      // Offset pixel hue by an amount to make one full revolution of the
      // color wheel (range of 65536) along the length of the Strip_1
      // (Strip_1.numPixels() steps):
      int pixelHue = firstPixelHue + (i * 65536L / Strip_1.numPixels());
      // Strip_1.ColorHSV() can take 1 or 3 arguments: a hue (0 to 65535) or
      // optionally add saturation and value (brightness) (each 0 to 255).
      // Here we're using just the single-argument hue variant. The result
      // is passed through Strip_1.gamma32() to provide 'truer' colors
      // before assigning to each pixel:
      Strip_1.setPixelColor(i, Strip_1.gamma32(Strip_1.ColorHSV(pixelHue)));
    }
    Strip_1.show(); // Update Strip_1 with new contents
    delay(wait);  // Pause for a moment
  }
}
